aws-0.16: Amazon Web Services (AWS) for Haskell

Safe Haskell | None
Language | Haskell2010

Aws.S3.Core

# Documentation

data S3Authorization #

Constructors

S3AuthorizationHeader |
S3AuthorizationQuery |

Instances

Show S3Authorization # |
Methods showsPrec :: Int -> S3Authorization -> ShowS # show :: S3Authorization -> String # showList :: [S3Authorization] -> ShowS #

data RequestStyle #

Constructors

PathStyle | Requires correctly setting region endpoint, but allows non-DNS compliant bucket names in the US standard region.
BucketStyle | Bucket name must be DNS compliant.
VHostStyle |

Instances

Show RequestStyle # |
Methods showsPrec :: Int -> RequestStyle -> ShowS # show :: RequestStyle -> String # showList :: [RequestStyle] -> ShowS #

data S3Configuration qt #

Constructors

S3Configuration |
Fields s3Protocol :: Protocol s3Endpoint :: ByteString s3RequestStyle :: RequestStyle s3Port :: Int s3ServerSideEncryption :: Maybe ServerSideEncryption s3UseUri :: Bool s3DefaultExpiry :: NominalDiffTime

Instances

Show (S3Configuration qt) # |
Methods showsPrec :: Int -> S3Configuration qt -> ShowS # show :: S3Configuration qt -> String # showList :: [S3Configuration qt] -> ShowS #
DefaultServiceConfiguration (S3Configuration UriOnlyQuery) # |
Methods defServiceConfig :: S3Configuration UriOnlyQuery # debugServiceConfig :: S3Configuration UriOnlyQuery #
DefaultServiceConfiguration (S3Configuration NormalQuery) # |
Methods defServiceConfig :: S3Configuration NormalQuery # debugServiceConfig :: S3Configuration NormalQuery #

s3EndpointUsClassic :: ByteString #

s3EndpointUsWest :: ByteString #

s3EndpointUsWest2 :: ByteString #

s3EndpointEu :: ByteString #

s3EndpointApSouthEast :: ByteString #

s3EndpointApSouthEast2 :: ByteString #

s3EndpointApNorthEast :: ByteString #

s3 :: Protocol -> ByteString -> Bool -> S3Configuration qt #

type ErrorCode = Text #

data S3Error #

Constructors

S3Error |
Fields s3StatusCode :: Status s3ErrorCode :: ErrorCode s3ErrorMessage :: Text s3ErrorResource :: Maybe Text s3ErrorHostId :: Maybe Text s3ErrorAccessKeyId :: Maybe Text s3ErrorStringToSign :: Maybe ByteString s3ErrorBucket :: Maybe Text s3ErrorEndpointRaw :: Maybe Text s3ErrorEndpoint :: Maybe ByteString

Instances

Show S3Error # |
Methods showsPrec :: Int -> S3Error -> ShowS # show :: S3Error -> String # showList :: [S3Error] -> ShowS #
Exception S3Error # |
Methods toException :: S3Error -> SomeException # fromException :: SomeException -> Maybe S3Error # displayException :: S3Error -> String #

data S3Metadata #

Constructors

S3Metadata |
Fields s3MAmzId2 :: Maybe Text s3MRequestId :: Maybe Text

Instances

Show S3Metadata # |
Methods showsPrec :: Int -> S3Metadata -> ShowS # show :: S3Metadata -> String # showList :: [S3Metadata] -> ShowS #
Monoid S3Metadata # |
Methods mempty :: S3Metadata # mappend :: S3Metadata -> S3Metadata -> S3Metadata # mconcat :: [S3Metadata] -> S3Metadata #
Loggable S3Metadata # |
Methods toLogText :: S3Metadata -> Text #

data S3Query #

Constructors

S3Query |
Fields s3QMethod :: Method s3QBucket :: Maybe ByteString s3QObject :: Maybe ByteString s3QSubresources :: Query s3QQuery :: Query s3QContentType :: Maybe ByteString s3QContentMd5 :: Maybe (Digest MD5) s3QAmzHeaders :: RequestHeaders s3QOtherHeaders :: RequestHeaders s3QRequestBody :: Maybe RequestBody

Instances

Show S3Query # |
Methods showsPrec :: Int -> S3Query -> ShowS # show :: S3Query -> String # showList :: [S3Query] -> ShowS #

s3SignQuery :: S3Query -> S3Configuration qt -> SignatureData -> SignedQuery #

s3ResponseConsumer :: HTTPResponseConsumer a -> IORef S3Metadata -> HTTPResponseConsumer a #

s3BinaryResponseConsumer :: HTTPResponseConsumer a -> IORef S3Metadata -> HTTPResponseConsumer a #

s3XmlResponseConsumer :: (Cursor -> Response S3Metadata a) -> IORef S3Metadata -> HTTPResponseConsumer a #

s3ErrorResponseConsumer :: HTTPResponseConsumer a #

type CanonicalUserId = Text #

data UserInfo #

Constructors

UserInfo |
Fields userId :: CanonicalUserId userDisplayName :: Text

Instances

Show UserInfo # |
Methods showsPrec :: Int -> UserInfo -> ShowS # show :: UserInfo -> String # showList :: [UserInfo] -> ShowS #

parseUserInfo :: MonadThrow m => Cursor -> m UserInfo #

data CannedAcl #

Constructors

AclPrivate |
AclPublicRead |
AclPublicReadWrite |
AclAuthenticatedRead |
AclBucketOwnerRead |
AclBucketOwnerFullControl |
AclLogDeliveryWrite |

Instances

Show CannedAcl # |
Methods showsPrec :: Int -> CannedAcl -> ShowS # show :: CannedAcl -> String # showList :: [CannedAcl] -> ShowS #

writeCannedAcl :: CannedAcl -> Text #

data StorageClass #

Constructors

Standard |
StandardInfrequentAccess |
ReducedRedundancy |
Glacier |
OtherStorageClass Text |

Instances

Show StorageClass # |
Methods showsPrec :: Int -> StorageClass -> ShowS # show :: StorageClass -> String # showList :: [StorageClass] -> ShowS #

parseStorageClass :: Text -> StorageClass #

writeStorageClass :: StorageClass -> Text #

data ServerSideEncryption #

Constructors

AES256 |

Instances

Show ServerSideEncryption # |
Methods showsPrec :: Int -> ServerSideEncryption -> ShowS # show :: ServerSideEncryption -> String # showList :: [ServerSideEncryption] -> ShowS #

parseServerSideEncryption :: MonadThrow m => Text -> m ServerSideEncryption #

writeServerSideEncryption :: ServerSideEncryption -> Text #

type Bucket = Text #

data BucketInfo #

Constructors

BucketInfo |
Fields bucketName :: Bucket bucketCreationDate :: UTCTime

Instances

Show BucketInfo # |
Methods showsPrec :: Int -> BucketInfo -> ShowS # show :: BucketInfo -> String # showList :: [BucketInfo] -> ShowS #

type Object = Text #

data ObjectId #

Constructors

ObjectId |
Fields oidBucket :: Bucket oidObject :: Object oidVersion :: Maybe Text

Instances

Show ObjectId # |
Methods showsPrec :: Int -> ObjectId -> ShowS # show :: ObjectId -> String # showList :: [ObjectId] -> ShowS #

data ObjectVersionInfo #

Constructors

ObjectVersion |
Fields oviKey :: Text oviVersionId :: Text oviIsLatest :: Bool oviLastModified :: UTCTime oviETag :: Text oviSize :: Integer oviStorageClass :: StorageClass oviOwner :: Maybe UserInfo
DeleteMarker |
Fields oviKey :: Text oviVersionId :: Text oviIsLatest :: Bool oviLastModified :: UTCTime oviOwner :: Maybe UserInfo

Instances

Show ObjectVersionInfo # |
Methods showsPrec :: Int -> ObjectVersionInfo -> ShowS # show :: ObjectVersionInfo -> String # showList :: [ObjectVersionInfo] -> ShowS #
ListResponse GetBucketObjectVersionsResponse ObjectVersionInfo # |
Methods listResponse :: GetBucketObjectVersionsResponse -> [ObjectVersionInfo] #

parseObjectVersionInfo :: MonadThrow m => Cursor -> m ObjectVersionInfo #

data ObjectInfo #

Constructors

ObjectInfo |
Fields objectKey :: Text objectLastModified :: UTCTime objectETag :: Text objectSize :: Integer objectStorageClass :: StorageClass objectOwner :: Maybe UserInfo

Instances

Show ObjectInfo # |
Methods showsPrec :: Int -> ObjectInfo -> ShowS # show :: ObjectInfo -> String # showList :: [ObjectInfo] -> ShowS #
ListResponse GetBucketResponse ObjectInfo # |
Methods listResponse :: GetBucketResponse -> [ObjectInfo] #

parseObjectInfo :: MonadThrow m => Cursor -> m ObjectInfo #

data ObjectMetadata #

Constructors

ObjectMetadata |
Fields omDeleteMarker :: Bool omETag :: Text omLastModified :: UTCTime omVersionId :: Maybe Text omUserMetadata :: [(Text, Text)] omMissingUserMetadata :: Maybe Text omServerSideEncryption :: Maybe ServerSideEncryption

Instances

Show ObjectMetadata # |
Methods showsPrec :: Int -> ObjectMetadata -> ShowS # show :: ObjectMetadata -> String # showList :: [ObjectMetadata] -> ShowS #

parseObjectMetadata :: MonadThrow m => ResponseHeaders -> m ObjectMetadata #

type LocationConstraint = Text #

locationUsClassic :: LocationConstraint #

locationUsWest :: LocationConstraint #

locationUsWest2 :: LocationConstraint #

locationEu :: LocationConstraint #

locationEuFrankfurt :: LocationConstraint #

locationApSouthEast :: LocationConstraint #

locationApSouthEast2 :: LocationConstraint #

locationApNorthEast :: LocationConstraint #

locationSA :: LocationConstraint #

normaliseLocation :: LocationConstraint -> LocationConstraint #